function $AdfDropTarget$$() {
  this.Init();
}
$goog$exportSymbol$$("AdfDropTarget", $AdfDropTarget$$);
$AdfObject$$.$createSubclass$($AdfDropTarget$$);
$AdfDropTarget$$.prototype.Init = function $$AdfDropTarget$$$$Init$() {
  $AdfDropTarget$$.$superclass$.Init.call(this);
  this.$_component$ = null;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.Init", {Init:$AdfDropTarget$$.prototype.Init});
$AdfDropTarget$$.prototype.$getComponent$ = function $$AdfDropTarget$$$$$getComponent$$() {
  return this.$_component$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.getComponent", {$getComponent$:$AdfDropTarget$$.prototype.$getComponent$});
$AdfDropTarget$$.prototype.$toDebugString$ = function $$AdfDropTarget$$$$$toDebugString$$() {
  return $AdfDropTarget$$.$superclass$.$toDebugString$.call(this) + "[source component:" + this.$_component$ + "]";
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.toDebugString", {$toDebugString$:$AdfDropTarget$$.prototype.$toDebugString$});
$AdfDropTarget$$.prototype.$acceptDragEnter$ = function $$AdfDropTarget$$$$$acceptDragEnter$$($dndContext$$16$$, $acceptedAction_proposedAction$$2$$, $pageX$$7$$, $pageY$$7$$) {
  $AdfLogger$$.$LOGGER$.finer("dragEnter:", this);
  $acceptedAction_proposedAction$$2$$ = this.$_acceptDrag$($dndContext$$16$$, $acceptedAction_proposedAction$$2$$, $pageX$$7$$, $pageY$$7$$);
  $acceptedAction_proposedAction$$2$$ != $AdfDnDContext$$.$ACTION_NONE$ && this.$AcceptedDragEnter$($dndContext$$16$$, $acceptedAction_proposedAction$$2$$, $pageX$$7$$, $pageY$$7$$);
  return $acceptedAction_proposedAction$$2$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.acceptDragEnter", {$acceptDragEnter$:$AdfDropTarget$$.prototype.$acceptDragEnter$});
$AdfDropTarget$$.prototype.$dragExit$ = function $$AdfDropTarget$$$$$dragExit$$() {
  $AdfLogger$$.$LOGGER$.finer("dragExit:", this);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.dragExit", {$dragExit$:$AdfDropTarget$$.prototype.$dragExit$});
$AdfDropTarget$$.prototype.$acceptDragOver$ = function $$AdfDropTarget$$$$$acceptDragOver$$($dndContext$$18$$, $proposedAction$$3$$, $pageX$$8$$, $pageY$$8$$) {
  $AdfLogger$$.$LOGGER$.finest("dragOver:", this);
  return this.$_acceptDrag$($dndContext$$18$$, $proposedAction$$3$$, $pageX$$8$$, $pageY$$8$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.acceptDragOver", {$acceptDragOver$:$AdfDropTarget$$.prototype.$acceptDragOver$});
$AdfDropTarget$$.prototype.$drop$ = function $$AdfDropTarget$$$$$drop$$($dndContext$$19$$, $proposedAction$$4$$, $componentX_pageX$$9$$, $componentY_pageY$$9$$) {
  $AdfAssert$$.assert($proposedAction$$4$$ != $AdfDnDContext$$.$ACTION_NONE$);
  $AdfLogger$$.$LOGGER$.finer("drop:", this);
  var $component$$74$$ = this.$_component$, $pagePosition$$ = $component$$74$$.$getPeer$().$getPagePosition$($component$$74$$);
  $componentX_pageX$$9$$ -= $pagePosition$$.x;
  $componentY_pageY$$9$$ -= $pagePosition$$.y;
  (new $AdfDropEvent$$($component$$74$$, $dndContext$$19$$.$getDragSource$(), $dndContext$$19$$.$getTransferable$(), $proposedAction$$4$$, $componentX_pageX$$9$$, $componentY_pageY$$9$$)).$queue$();
  return $AdfDnDContext$$.$ACTION_NONE$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.drop", {$drop$:$AdfDropTarget$$.prototype.$drop$});
$AdfDropTarget$$.prototype.$acceptDropActionChanged$ = function $$AdfDropTarget$$$$$acceptDropActionChanged$$($dndContext$$20$$, $proposedAction$$5$$, $pageX$$10$$, $pageY$$10$$) {
  $AdfLogger$$.$LOGGER$.finest("dropActionChanged:", this, " proposed:", $proposedAction$$5$$);
  return this.$_acceptDrag$($dndContext$$20$$, $proposedAction$$5$$, $pageX$$10$$, $pageY$$10$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.acceptDropActionChanged", {$acceptDropActionChanged$:$AdfDropTarget$$.prototype.$acceptDropActionChanged$});
$AdfDropTarget$$.prototype.$AcceptDrag$ = function $$AdfDropTarget$$$$$AcceptDrag$$($dndContext$$21$$, $possibleActions$$, $proposedAction$$6$$) {
  var $flavorAcceptance$$ = $dndContext$$21$$.$getDropTargetProperty$("DropTarget:flavorAcceptance");
  null == $flavorAcceptance$$ && ($flavorAcceptance$$ = this.$CalculateFlavorAcceptance$($dndContext$$21$$), $dndContext$$21$$.$setDropTargetProperty$("DropTarget:flavorAcceptance", $flavorAcceptance$$));
  $AdfAssert$$.$assertBoolean$($flavorAcceptance$$);
  return $flavorAcceptance$$ ? $proposedAction$$6$$ & $possibleActions$$ ? $proposedAction$$6$$ : $possibleActions$$ & $AdfDnDContext$$.$ACTION_MOVE$ ? $AdfDnDContext$$.$ACTION_MOVE$ : $possibleActions$$ & $AdfDnDContext$$.$ACTION_COPY$ ? $AdfDnDContext$$.$ACTION_COPY$ : $possibleActions$$ & $AdfDnDContext$$.$ACTION_LINK$ ? $AdfDnDContext$$.$ACTION_LINK$ : $AdfDnDContext$$.$ACTION_NONE$ : $AdfDnDContext$$.$ACTION_NONE$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.AcceptDrag", {$AcceptDrag$:$AdfDropTarget$$.prototype.$AcceptDrag$});
$AdfDropTarget$$.prototype.$CalculateFlavorAcceptance$ = function $$AdfDropTarget$$$$$CalculateFlavorAcceptance$$($dndContext$$22_transferable$$4$$) {
  var $allowedFlavors$$2$$ = this.$GetAllowedFlavors$($dndContext$$22_transferable$$4$$);
  $AdfAssert$$.$assertArrayOrNull$($allowedFlavors$$2$$);
  var $allowedCount$$ = $allowedFlavors$$2$$ ? $allowedFlavors$$2$$.length : 0;
  $dndContext$$22_transferable$$4$$ = $dndContext$$22_transferable$$4$$.$getTransferable$();
  for (var $i$$47$$ = 0;$i$$47$$ < $allowedCount$$;$i$$47$$++) {
    if ($dndContext$$22_transferable$$4$$.$isDataFlavorSupported$($allowedFlavors$$2$$[$i$$47$$])) {
      return !0;
    }
  }
  return !1;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.CalculateFlavorAcceptance", {$CalculateFlavorAcceptance$:$AdfDropTarget$$.prototype.$CalculateFlavorAcceptance$});
$AdfDropTarget$$.prototype.$AcceptedDragEnter$ = function $$AdfDropTarget$$$$$AcceptedDragEnter$$() {
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.AcceptedDragEnter", {$AcceptedDragEnter$:$AdfDropTarget$$.prototype.$AcceptedDragEnter$});
$AdfDropTarget$$.prototype.$GetAllowedActions$ = function $$AdfDropTarget$$$$$GetAllowedActions$$() {
  return $AdfDnDContext$$.$ACTIONS_ALL$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.GetAllowedActions", {$GetAllowedActions$:$AdfDropTarget$$.prototype.$GetAllowedActions$});
$AdfDropTarget$$.prototype.$GetAllowedFlavors$ = function $$AdfDropTarget$$$$$GetAllowedFlavors$$() {
  return null;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.GetAllowedFlavors", {$GetAllowedFlavors$:$AdfDropTarget$$.prototype.$GetAllowedFlavors$});
$AdfDropTarget$$.prototype.$__setComponent$ = function $$AdfDropTarget$$$$$__setComponent$$($component$$75$$) {
  this.$_component$ = $component$$75$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfDropTarget.prototype.__setComponent", {$__setComponent$:$AdfDropTarget$$.prototype.$__setComponent$});
$AdfDropTarget$$.prototype.$_acceptDrag$ = function $$AdfDropTarget$$$$$_acceptDrag$$($dndContext$$26$$, $proposedAction$$7$$, $pageX$$13$$, $pageY$$13$$) {
  $AdfAssert$$.$assertNumber$($pageX$$13$$);
  $AdfAssert$$.$assertNumber$($pageY$$13$$);
  var $possibleActions$$1$$ = this.$GetAllowedActions$() & $dndContext$$26$$.$getSourceActions$();
  return $possibleActions$$1$$ ? this.$AcceptDrag$($dndContext$$26$$, $possibleActions$$1$$, $proposedAction$$7$$, $pageX$$13$$, $pageY$$13$$) : $AdfDnDContext$$.$ACTION_NONE$;
};
